local L = AceLibrary("AceLocale-2.2"):new("Automaton_Dismount")
Automaton_Dismount = Automaton:NewModule("Dismount", "AceEvent-2.0", "AceDebug-2.0")
local module = Automaton_Dismount

L:RegisterTranslations("enUS", function() return {
    ["Dismount"] = true,
	["Automatically dismount when you receive the 'You are mounted' error"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["Dismount"] = "탈것 내림",
	["Automatically dismount when you receive the 'You are mounted' error"] = "'탈것 내리기' 오류시 자동으로 탈것에서 내립니다.",	
} end)

L:RegisterTranslations("esES", function() return {
    ["Dismount"] = "Desmontar",
	["Automatically dismount when you receive the 'You are mounted' error"] = "Te desmonta autom\195\161ticamente cuando recibes el error 'Est\195\161s montado'",
} end)

L:RegisterTranslations("zhTW", function() return {
["Dismount"] = "自動下馬",
["Automatically dismount when you receive the 'You are mounted' error"] = "當收到'您正在騎乘狀態' 的訊息時自動下馬",
} end)

module.description = L["Automatically dismount when you receive the 'You are mounted' error"]
module.options = {
}

function module:OnInitialize()
    self.db = Automaton:AcquireDBNamespace("Dismount")
    Automaton:RegisterDefaults("Dismount", "profile", {
		disabled = true,
    })
	Automaton:SetDisabledAsDefault(self, "Dismount")
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("UI_ERROR_MESSAGE")
end

local messages = {
	[ERR_TAXIPLAYERALREADYMOUNTED] = true,
	[ERR_ATTACK_MOUNTED] = true,
	[SPELL_FAILED_NOT_MOUNTED] = true,
	[SPELL_FAILED_OUT_OF_RANGE] = true,
	[ERR_OUT_OF_RANGE] = true,
	[ERR_PET_SPELL_OUT_OF_RANGE] = true,
}

function module:UI_ERROR_MESSAGE(msg)
	if UnitOnTaxi("player") then return end
	if not messages[msg] then return end

	if IsMounted() and not IsFlying() then
		Dismount()
	end	
end