local L = AceLibrary("AceLocale-2.2"):new("Automaton_Rez")
Automaton_Rez = Automaton:NewModule("Rez", "AceEvent-2.0", "AceConsole-2.0", "AceDebug-2.0")
local module = Automaton_Rez

L:RegisterTranslations("enUS", function() return {
    ["Rez"] = true,
	["Options for accepting resurrection requests."] = true,
    ["Enabled"] = true,
	["Accept resurrection requests. If the persist option is Off, AutoRez will disable itself after the first resurrection."] = true,
    ["Persist"] = true,
	["With this option enabled, AutoRez will persist for every resurrection request."] = true,
	["Delay"] = true,
	["With this option enabled, automatic resurrection accept is delayed for 100 seconds."] = true,
	["Accepting resurrect in 1:40"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["Rez"] = "자동 부활",
	["Options for accepting resurrection requests."] = "부활에 관한 옵션을 설정합니다.",
    ["Enabled"] = "활성화",
	["Accept resurrection requests. If the persist option is Off, AutoRez will disable itself after the first resurrection."] = "부활을 자동 수락합니다. 지속 옵션이 체크되어 있지 않으면, 자동 부활은 첫째 부활 후에 그 자체를 비활성화합니다.",
    ["Persist"] = "지속",
	["With this option enabled, AutoRez will persist for every resurrection request."] = "이 옵션이 활성화시, 모든 부활 요구가 지속됩니다.",
	["Delay"] = "지연",
	["With this option enabled, automatic resurrection accept is delayed for 100 seconds."] = "이 옵션이 활성화시, 자동 부활 수락을 100초 동안 지연시킵니다.",
	["Accepting resurrect in 1:40"] = "부활 수락 1:40",
} end)

L:RegisterTranslations("esES", function() return {
    ["Rez"] = "Resucitar",
	["Options for accepting resurrection requests."] = "Opciones para aceptar las ofertas de resurrecci\195\179n",
    ["Enabled"] = "Activado",
	["Accept resurrection requests. If the persist option is Off, AutoRez will disable itself after the first resurrection."] = "Acepta las ofertas de resurrecci\195\179n. Si la opci\195\179n Persistir est\195\161 Desactivada se desactivar\195\161 la resurrecci\195\179n autom\195\161tica tras la primera resurrecci\195\179n",
    ["Persist"] = "Persistir",
	["With this option enabled, AutoRez will persist for every resurrection request."] = "La resurrecci\195\179n autom\195\161tica seguir\195\161 activa para todas las ofertas de resurrecci\195\179n",
	["Delay"] = "Retraso",
	["With this option enabled, automatic resurrection accept is delayed for 100 seconds."] = "La aceptaci\195\179n de la resurrecci\195\179n autom\195\161tica se retrasa 100 segundos",
	["Accepting resurrect in 1:40"] = "Aceptando resurrecci\195\179n en 1:40m",
} end)

L:RegisterTranslations("zhTW", function() return {
    ["Rez"] = "自動復活",
	["Options for accepting resurrection requests."] = "自動接受復活",
    ["Enabled"] = "啟用",
	["Accept resurrection requests. If the persist option is Off, AutoRez will disable itself after the first resurrection."] = "自動接受復活",
    ["Persist"] = "持續",
	["With this option enabled, AutoRez will persist for every resurrection request."] = "此項開啟將自動接受復活",
	["Delay"] = "延遲",
	["With this option enabled, automatic resurrection accept is delayed for 100 seconds."] = "當提示出現後延遲100秒後自動接受復活",
	["Accepting resurrect in 1:40"] = "1分40秒後自動接受復活",
} end)

module.description = L["Options for accepting resurrection requests."]
module.options = {
	persist = {
		type = 'toggle',
		name = L["Persist"],
		desc = L["With this option enabled, AutoRez will persist for every resurrection request."],
		get = function() return module.db.profile.persist end,
		set = function(v) module.db.profile.persist = v end,
	},
	delay = {
		type = 'toggle',
		name = L["Delay"],
		desc = L["With this option enabled, automatic resurrection accept is delayed for 100 seconds."],
		get = function() return module.db.profile.delay end,
		set = function(v) module.db.profile.delay = v end,
	}
}

function module:OnInitialize()
    self.db = Automaton:AcquireDBNamespace("Rez")
    Automaton:RegisterDefaults("Rez", "profile", {
		disabled = true,
        persist = false,
        delay = false,
    })
	Automaton:SetDisabledAsDefault(self, "Rez")
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("RESURRECT_REQUEST")
end

function module:RESURRECT_REQUEST()
	if module.db.profile.delay and not self:IsEventScheduled("module") then
		self:Print(L["Accepting resurrect in 1:40"])
		self:ScheduleEvent("module", function()
			AcceptResurrect()
			StaticPopup_Hide("RESURRECT_NO_SICKNESS")
		end, 100)
	elseif not self:IsEventScheduled("module") then
		AcceptResurrect()
		StaticPopup_Hide("RESURRECT_NO_SICKNESS")
	end
	if not module.db.profile.persist then
		Automaton:ToggleModuleActive("Rez",false)
	end
end